<?php
class Person
{
	public $id,$type,$name,$thumb,$pic,$isMale,$hairColor,$eyeColor;
	public $hasGlasses,$hasMakeup,$hasEarrings,$hasMustache,$hasBeard,$hasHat;

	function __construct($data,$type='computer')
	{
		$this->id= $data[0];
		$this->type= $type;
		$this->name= ucfirst($data[0]);
		if ($type=='user')
			$this->thumb= 'img/'.$this->id.'_thumb.png';
		else
			$this->thumb= 'img/'.$this->id.'_thumb.png';	// don't have an image for this yet
		$this->isMale= ucfirst($data[1])=='M';
		$this->hairColor= $data[2];
		$this->eyeColor= $data[3];
		$this->hasGlasses= $data[4]=='yes';
		$this->hasMakeup= $data[5]=='yes';
		$this->hasEarrings= $data[6]=='yes';
		$this->hasMustache= $data[7]=='yes';
		$this->hasBeard= $data[8]=='yes';
		$this->hasHat= $data[9]=='yes';
	}

	function makeCard()
	{
		if ($this->type=='user')
			echo "	<div id=\"$this->id\" class=\"card\" style=\"background-image:url('$this->thumb')\"></div>\n";
		else
			echo "	<div id=\"$this->id\" class=\"card\" style=\"background-image:url('$this->thumb')\"></div>\n"; // change this later
	}
	function show()
	{
		echo $this->name."<br/>\n";
	}

	function json()
	{
		$arr= get_object_vars($this);
		echo '{';
		foreach ($arr as $index=>$value)
			echo "\"$index\":\"$value\",";
		echo "\"end\":\"end\"}";
	}
}

class Grid
{
	public $list,$n,$type;

	// if type is computer we randomize the order so user can't
	// know the position of it's cards
	function __construct($csvfile,$type='computer')
	{
		$this->type= $type;
		if (($handle = fopen($csvfile, "r")) !== FALSE) {
			$data= fgetcsv($handle, 1000, ",");		// toss out header line
			$this->n= 0;
			while (($data = fgetcsv($handle, 1000, ",")) !== FALSE)
				$this->list[$this->n++]= new Person($data,$type);
			fclose($handle);

			if ($type!='user')
				shuffle($this->list);
		}
		else echo "no open\n";
	}
	
			/*
			NOTE: This code is used to extract json data that comes directly from google docs
						It is necessary to put double quotes around everything before json_decode will extract it
			echo "<pre>\n";
			$line= fgets($handle);
			//$pos= strpos($line,'(')+1;
			$line= substr($line,strpos($line,'(')+1);
			$line= rtrim($line,' );');
			$line= preg_replace("/(\w+):/","\"$1\":",$line);
			$line= preg_replace("/'/","\"",$line);
			echo $line;
			var_dump(json_decode($line));
			//echo $result;
			echo "</pre>\n";
			*/

	function show()
	{
		for ($i=0; $i<$this->n; $i++)
			$this->list[$i]->show();
	}


	function makeGrid()
	{
		echo "  <div class=\"alpha grid_9 omega ugrid\">\n";
		for ($i=0; $i<$this->n; $i++) {
			$this->list[$i]->makeCard();
			if ($i%6==5)
				echo '  <div class="clear">hello</div>'."\n";
		}
		echo "  </div>\n";
	}

	function json()
	{
		echo '[';
		$this->list[0]->json();
		for ($i=1; $i<$this->n; $i++) {
			echo ",";
			$this->list[$i]->json();
		}
		echo ']';
		
	}
	//function size() { return $this->n; }
}

